(define-module (ui mirror ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator effect)
    :export (init))

(define *parameters* '("storage_avail" "period" "weekday" "monthday" "time"))

(define (ui-read)
  (catch/message
    (lambda()
      (form-update-value-list *parameters* (woo-read-first "/mirror" 'language (form-value "language")))
      (update-effect))))

(define (ui-write)
  (catch/message
    (lambda()
      (apply woo-write "/mirror"
             'language (form-value "language")
             (form-value-list *parameters*))
      (ui-read))))

(define (init)
  ;; lists
  (form-update-enum "repository" (woo-list "/mirror/avail_repository" 'language (form-value "language")))
  (form-update-enum "weekday" (woo-list "/mirror/avail_weekday" 'language (form-value "language")))

  ;; effects
  (effect-enable "weekday" "period" "weekly")
  (effect-enable "monthday" "period" "monthly")
  (effect-disable "time" "period" "off")
  (init-effect)
  ;; form
  (ui-read)

  ;; events
  (form-bind "apply" "click" ui-write)
  (form-bind "reset" "click" ui-read))
